﻿Option Strict On
Option Explicit On
Public Class Form1
    Dim bFlag As Boolean = False
    Dim bFlag2 As Boolean = False
    Private t1 As Timer
    Private t2 As Timer
    Private tw As myTimerClass

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        tw = New myTimerClass(Me)
    End Sub
    Private Sub Form1_FormClosed(sender As Object, e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        tw.finish()
    End Sub
    Private Sub btnClose_Click(sender As System.Object, e As System.EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub
    Private Sub btnStopTimer_Click(sender As System.Object, e As System.EventArgs) Handles btnStopTimer.Click
        If t2 IsNot Nothing Then
            t2.Stop()
            t2.Dispose()
            t2 = Nothing
        End If        
    End Sub
    Private Sub btnStartTimer_Click(sender As System.Object, e As System.EventArgs) Handles btnStartTimer.Click
        If t2 Is Nothing Then
            t2 = New Timer
            With t2
                .Enabled = True
                .Interval = 50
                .Start()
                AddHandler .Tick, AddressOf Me.t2_tick
            End With
            Me.pgShow2.Value = 0
            Me.pgShow2.Maximum = 1000
        End If
    End Sub
    Private Sub t1_tick(ByVal sender As Object, ByVal e As EventArgs)
        If Not bFlag Then
            If (Me.pgShow.Value >= Me.pgShow.Maximum) Then
                bFlag = True
            Else : Me.pgShow.Value += 10
            End If
        End If
        If bFlag Then
            If (Me.pgShow.Value <= 0) Then
                bFlag = False
            Else : Me.pgShow.Value -= 10
            End If
        End If
    End Sub
    Private Sub t2_tick(ByVal sender As Object, ByVal e As EventArgs)
        If Not bFlag2 Then
            If (Me.pgShow2.Value >= Me.pgShow2.Maximum) Then
                bFlag2 = True
            Else : Me.pgShow2.Value += 10
            End If
        End If
        If bFlag2 Then
            If (Me.pgShow2.Value <= 0) Then
                bFlag2 = False
            Else : Me.pgShow2.Value -= 10
            End If
        End If
    End Sub
    Public Sub New()
        MyBase.new()
        Me.InitializeComponent()
        Me.CenterToScreen()

        t1 = New Timer
        With t1
            .Enabled = True
            .Interval = 50
            .Start()
            AddHandler .Tick, AddressOf Me.t1_tick
        End With
        Me.pgShow.Value = 0
        Me.pgShow.Maximum = 1000
    End Sub
End Class

Public Class myTimerClass
    Private cnt As Integer = 0
    Private frm As Form1
    Private t3 As Timer
    Public Sub finish()
        If t3 IsNot Nothing Then
            t3.Stop()
            t3.Dispose()
            t3 = Nothing
        End If
    End Sub
    Private Sub t3_tick(ByVal sender As Object, ByVal e As EventArgs)
        cnt += 1
        frm.TextBox1.Text = cnt.ToString
    End Sub
    Public Sub New(ByRef f As Form1)
        Me.frm = f
        Me.cnt = 0
        t3 = New Timer
        With t3
            .Enabled = True
            .Interval = 1000
            .Start()
            AddHandler .Tick, AddressOf Me.t3_tick
        End With
    End Sub
End Class